Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemMultiValueControl.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemMultiValueControl.cs	(revision 17484)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemMultiValueControl.cs	(revision 17485)
@@ -182,30 +182,38 @@
     #region Validation
     private void textBoxRows_Validating(object sender, CancelEventArgs e) {
-      if (string.IsNullOrWhiteSpace(textBoxRows.Text)) {
-        errorProvider.SetError(textBoxRows, "'Rows' must not be empty.");
-        e.Cancel = true;
-      } else if (!int.TryParse(textBoxRows.Text, out int r)) {
-        errorProvider.SetError(textBoxRows, "Value of 'Rows' must be an integer.");
-        e.Cancel = true;
-      } else if (r == 0) {
-        errorProvider.SetError(textBoxRows, "Value of 'Rows' must be an integer larger than 0.");
-        e.Cancel = true;
-      } else {
+      if (textBoxRows.ReadOnly) {
         errorProvider.SetError(textBoxRows, null);
+      } else {
+        if (string.IsNullOrWhiteSpace(textBoxRows.Text)) {
+          errorProvider.SetError(textBoxRows, "'Rows' must not be empty.");
+          e.Cancel = true;
+        } else if (!int.TryParse(textBoxRows.Text, out int r)) {
+          errorProvider.SetError(textBoxRows, "Value of 'Rows' must be an integer.");
+          e.Cancel = true;
+        } else if (r == 0) {
+          errorProvider.SetError(textBoxRows, "Value of 'Rows' must be an integer larger than 0.");
+          e.Cancel = true;
+        } else {
+          errorProvider.SetError(textBoxRows, null);
+        }
       }
     }
 
     private void textBoxColumns_Validating(object sender, CancelEventArgs e) {
-      if (string.IsNullOrWhiteSpace(textBoxColumns.Text)) {
-        errorProvider.SetError(textBoxColumns, "'Columns' must not be empty.");
-        e.Cancel = true;
-      } else if (!int.TryParse(textBoxColumns.Text, out int r)) {
-        errorProvider.SetError(textBoxColumns, "Value of 'Columns' must be an integer.");
-        e.Cancel = true;
-      } else if (r == 0) {
-        errorProvider.SetError(textBoxColumns, "Value of 'Columns' must be an integer larger than 0.");
-        e.Cancel = true;
-      } else {
+      if (textBoxColumns.ReadOnly) {
         errorProvider.SetError(textBoxColumns, null);
+      } else {
+        if (string.IsNullOrWhiteSpace(textBoxColumns.Text)) {
+          errorProvider.SetError(textBoxColumns, "'Columns' must not be empty.");
+          e.Cancel = true;
+        } else if (!int.TryParse(textBoxColumns.Text, out int r)) {
+          errorProvider.SetError(textBoxColumns, "Value of 'Columns' must be an integer.");
+          e.Cancel = true;
+        } else if (r == 0) {
+          errorProvider.SetError(textBoxColumns, "Value of 'Columns' must be an integer larger than 0.");
+          e.Cancel = true;
+        } else {
+          errorProvider.SetError(textBoxColumns, null);
+        }
       }
     }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ConstrainedValueParameterConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ConstrainedValueParameterConverter.cs	(revision 17484)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ConstrainedValueParameterConverter.cs	(revision 17485)
@@ -21,5 +21,5 @@
       if (parameter.ActualValue != null && parameter.ActualValue is IParameterizedItem && cdata.Children != null) {
         foreach(var child in cdata.Children) {
-          if(child.Name == cdata.Value || child.Path.EndsWith(cdata.Value))
+          if(child.Name == cdata.Value || child.Path.EndsWith(cdata.Value) || child.Name == parameter.ActualValue.ItemName)
             root.Inject(parameter.ActualValue, child, root);
         }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/JsonItem.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/JsonItem.cs	(revision 17484)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/JsonItem.cs	(revision 17485)
@@ -42,11 +42,14 @@
 
       public ValidationResult Validate() {
-        IEnumerable<string> errors = Enumerable.Empty<string>();
+        List<string> errors = new List<string>();
         bool success = true;
         foreach(var x in Root) {
-          var res = ((JsonItem)x).Validate();
-          //if one success is false -> whole validation is false
-          success = success && res.Success; 
-          errors.Concat(res.Errors);
+          JsonItem item = x as JsonItem;
+          if(item.Active) {
+            var res = ((JsonItem)x).Validate();
+            //if one success is false -> whole validation is false
+            success = success && res.Success;
+            errors.AddRange(res.Errors);
+          }
         }
         return new ValidationResult(success, errors);